include \masm32\include\masm32rt.inc		; see also [url=http://www.masm32.com/board/index.php?topic=10673.msg78203#msg78203]varprint[/url] (Bogdan + jj)

TestC1	PROTO C :DWORD, :VARARG
TestC2	PROTO C :DWORD, :VARARG

invva MACRO algo, args:VARARG
LOCAL ct
  ct=0
  FOR arg, <args>
	push arg
	ct = ct +1
  ENDM
  push ct
  call algo
ENDM

invB MACRO algo, args:VARARG
LOCAL ct, pu$, pm$, pc$, pos
  ct=0
  pu$ equ < >
  FOR arg, <args>
  	pu$ CATSTR <push >, <arg>, <#>, pu$
	ct = ct +1
  ENDM
  pc$ CATSTR <push >, %ct
  tmp$ CATSTR <Myarg=>, pu$, <, ct=>, %ct
  % echo tmp$
  WHILE ct
  	pos INSTR pu$, <#>
  	pm$ SUBSTR pu$, 1, pos-1
  	pu$ SUBSTR pu$, pos+1
  	tmp$ CATSTR <Myarg=>, pm$, <, pos >, %pos, <, ct >, %ct
	% echo tmp$
  	pm$
  	ct = ct -1 
  ENDM
  pc$
  call algo
ENDM

.data
MyString1	db 13, 10, "A string ", 0
MyString2	db "concatenation demo ", 0
MyString3	db "using a variable ", 0
MyString4	db "number of arguments", 0
AppName	db "Test vararg", 13, 10, 0

.code
start:
	mov esi, esp
	invva TestA,  offset MyString1
	invva TestA,  offset MyString1, offset MyString2
	invva TestA,  offset MyString1, offset MyString2, offset MyString3
	invva TestA,  offset MyString1, offset MyString2, offset MyString3, offset MyString4
	invva TestA,  offset MyString1, offset MyString2, offset MyString3 
	invva TestA,  offset MyString1, offset MyString2
	invva TestA,  offset MyString1
	invva TestA
	invB TestB,  offset MyString1
	invB TestB,  offset MyString1, offset MyString2
	invB TestB,  offset MyString1, offset MyString2, offset MyString3
	invB TestB,  offset MyString1, offset MyString2, offset MyString3, offset MyString4
	invB TestB,  offset MyString1, offset MyString2, offset MyString3
	invB TestB,  offset MyString1, offset MyString2
	invB TestB,  offset MyString1
	invB TestB
	invoke TestC1,  1, offset MyString1
	invoke TestC1,  2, offset MyString2, offset MyString1
	invoke TestC1,  3, offset MyString3, offset MyString2, offset MyString1
	invoke TestC1,  4, offset MyString4, offset MyString3, offset MyString2, offset MyString1
	invoke TestC1,  3, offset MyString3, offset MyString2, offset MyString1
	invoke TestC1,  2, offset MyString2, offset MyString1
	invoke TestC1,  1, offset MyString1
	invoke TestC1,  0
	invoke TestC2,  1, offset MyString1
	invoke TestC2,  2, offset MyString1, offset MyString2
	invoke TestC2,  3, offset MyString1, offset MyString2, offset MyString3
	invoke TestC2,  4, offset MyString1, offset MyString2, offset MyString3, offset MyString4
	invoke TestC2,  3, offset MyString1, offset MyString2, offset MyString3
	invoke TestC2,  2, offset MyString1, offset MyString2
	invoke TestC2,  1, offset MyString1
	invoke TestC2,  0
	sub esi, esp
	print chr$(13, 10, 10)
	.if esi
		print str$(esi), " bytes stack difference"
	.else
		print "stack OK"
	.endif
	print chr$(13, 10, 10, "Sizes of proc skeleton including loop and stack correction:", 13, 10)

ShowMeA	= 9	; 0 for skeleton only - 9 bytes is the size of print [esp+4*ebx+12]
ShowMeB	= 6	; 0 for skeleton only - 6 bytes is the size of print edx
ShowMeC	= 9	; 0 for skeleton only - 9 bytes is the size of print [esp+4*ebx+12]

	mov eax, TestA_END
	sub eax, TestA
	sub eax, ShowMeA
	print str$(eax), 9, "TestA: no extra bytes per call", 13, 10
	mov eax, TestB_END
	sub eax, TestB
	sub eax, ShowMeB
	print str$(eax), 9, "TestB: no return value", 13, 10
	mov eax, TestC1_END
	sub eax, TestC1
	sub eax, ShowMeC
	print str$(eax), 9, "TestC1: +3 bytes per call, order of args inverted", 13, 10
	mov eax, TestC2_END
	sub eax, TestC2
	sub eax, ShowMeC
	print str$(eax), 9, "TestC2: +3 bytes per call", 13, 10

	inkey "Press any key"
	exit

TestA proc 		; varargs on stack; no need for PROTO & OPTION PRO
  push ebx
  mov ebx, [esp+8]
  .Repeat
	dec ebx
	.Break .if Sign?
	push [esp+4*ebx+12]	; or do other stuff
	call StdOut
  .Until 0
  pop ebx
  pop edx		; pop ret address
  pop ecx		; pop counter
  lea esp, [esp+4*ecx]	; stack correction
  jmp dword ptr edx	; returns StdOut eax
TestA endp
TestA_END:

;	The stack on proc entry:
; [esp+C]	arg2
; [esp+8]	arg1
; [esp+4]	counter
; [esp+0]	ret

TestB proc 		; varargs on stack; no need for PROTO & OPTION PRO
  pop eax	; pop ret address
  pop ecx	; pop counter
  .Repeat
	dec ecx
	.Break .if Sign?
	pop edx		; get next arg
	pushad		; save counter and ret address
	print edx	; or do other stuff
	popad
  .Until 0
  push eax	; restore ret address
  ret	; no return value
TestB endp
TestB_END:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
TestC1 proc C counter:DWORD, args:VARARG 	; varargs on stack
  push ebx
  mov ebx, [esp+8]			; get counter
  .Repeat
	dec ebx
	.Break .if Sign?
	push [esp+4*ebx+12]	; or do other stuff
	call StdOut
  .Until 0
  pop ebx
  ret		; may return eax
TestC1 endp
TestC1_END:

TestC2 proc C counter:DWORD, args:VARARG 	; varargs on stack
  push ebx
  xor ebx, ebx
  .Repeat
	inc ebx
	.Break .if ebx>[esp+8]
	push [esp+4*ebx+8]	; or do other stuff
	call StdOut
  .Until 0
  pop ebx
  ret		; may return eax
TestC2 endp
TestC2_END:

end start

RichMasm options:
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; linker options for ultra short executables
OPT_WAIT	0	; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
